sdr::Scale< Scalar > Class Template Reference
Filter and signal processing nodes.

Simple scaling node. More...

`#include <utils.hh>`

Inheritance diagram for sdr::Scale< Scalar >:

## Public Member Functions

| Scale (float scale=1, Scalar shift=0)
| Constructs the scaling node. More...
virtual | ~Scale ()
| Destructor. More...
virtual void | config (const Config &src_cfg)
| Configures the scaleing node. More...
virtual void | process (const Buffer< Scalar > &buffer, bool allow_overwrite)
| Performs the scaleing. More...
Public Member Functions inherited from sdr::Sink< Scalar >
| Sink ()
| Constructor. More...
virtual | ~Sink ()
| Drestructor. More...
virtual void | handleBuffer (const RawBuffer &buffer, bool allow_overwrite)
| Re-implemented from `SinkBase`. More...
Public Member Functions inherited from sdr::SinkBase
| SinkBase ()
| Constructor. More...
virtual | ~SinkBase ()
| Destructor. More...
Public Member Functions inherited from sdr::Source
| Source ()
| Constructor. More...
virtual | ~Source ()
| Destructor. More...
virtual void | send (const RawBuffer &buffer, bool allow_overwrite=false)
| Sends the given buffer to all connected sinks. More...
void | connect (SinkBase *sink, bool direct=false)
| Connect this source to a sink. More...
void | disconnect (SinkBase *sink)
| Disconnect a sink again. More...
virtual void | setConfig (const Config &config)
| Stores the configuration and propergates it if the configuration has been changed. More...
virtual double | sampleRate () const
| Returns the configured sample rate or `0` otherwise. More...
virtual Config::Type | type () const
| Returns the configured source type or `Config::Type_UNDEFINED` otherwise. More...
template<class T >
void | addEOS (T *instance, void(T::*function)())
| Adds a callback to the end-of-stream signal of the source. More...

## Protected Attributes

Buffer< Scalar > | _buffer
| The output buffer, unused if the scaling is performed in-place. More...
float | _scale
| The scaling. More...
Scalar | _shift
| Alternative formulation for the scaling, using integer shift operators. More...
Protected Attributes inherited from sdr::Source
Config | _config
| Holds the source configuration, this can be updated by calling `setConfig`. More...
std::map< SinkBase *, bool > | _sinks
| The connected sinks. More...
std::list< DelegateInterface * > | _eos
| The connected EOS singal handlers. More...

## Additional Inherited Members

Protected Member Functions inherited from sdr::Source
void | signalEOS ()
| Signals the EOS. More...
void | propagateConfig (const Config &config)
| Propagates the given configuration to all connected sinks. More...

## Detailed Description

### template<class Scalar>
class sdr::Scale< Scalar >

Simple scaling node.

## Constructor & Destructor Documentation

template<class Scalar >

sdr::Scale< Scalar >::Scale | ( | float | scale = `1`,
|  | Scalar | shift = `0`
| ) |  |

inline

Constructs the scaling node.

template<class Scalar >

virtual sdr::Scale< Scalar >::~Scale | ( |  | ) |

inlinevirtual

Destructor.

## Member Function Documentation

template<class Scalar >

virtual void sdr::Scale< Scalar >::config | ( | const Config & | src_cfg | ) |

inlinevirtual

Configures the scaleing node.

Implements sdr::SinkBase.

template<class Scalar >

virtual void sdr::Scale< Scalar >::process | ( | const Buffer< Scalar > & | buffer,
|  | bool | allow_overwrite
| ) |  |

inlinevirtual

Performs the scaleing.

Implements sdr::Sink< Scalar >.

## Member Data Documentation

template<class Scalar >

Buffer<Scalar> sdr::Scale< Scalar >::_buffer

protected

The output buffer, unused if the scaling is performed in-place.

template<class Scalar >

float sdr::Scale< Scalar >::_scale

protected

The scaling.

template<class Scalar >

Scalar sdr::Scale< Scalar >::_shift

protected

Alternative formulation for the scaling, using integer shift operators.

The documentation for this class was generated from the following file:

- /Users/hannes/Uni/Elektronik/sdr/libsdr/src/utils.hh